function isFunction(o){
	return typeof o === "function";
}

function objToString(obj, ndeep){
	if(ndeep === undefined){ ndeep = 1; }
	if(obj == null){ return String(obj); }
	if(typeof obj == "string"){ return '"'+obj+'"'; }
	if(typeof obj == "function"){ return obj.name || obj.toString(ndeep); }
	if(Array.isArray(obj)){
		return '[' + obj.map(function(item) {
				return objToString(item, ndeep);
			}).join(', ') + ']';
	}
	if(obj instanceof ArrayModel){ return obj.toString(ndeep); }
	if(obj && typeof obj == "object"){
		var indent = (new Array(ndeep)).join('\t');
		return '{' + Object.keys(obj).map(function(key){
				return '\n\t' + indent + key + ': ' + objToString(obj[key], ndeep+1);
			}).join(',') + '\n' + indent + '}';
	}
	return String(obj)
}

function bettertypeof(obj){
	return ({}).toString.call(obj).match(/\s([a-zA-Z]+)/)[1];
}

function arrayCopy(arr){
	return Array.prototype.slice.call(arr);
}

function merge(base, ext){
	if(ext instanceof Object){
		for(var p in ext){
			if(ext.hasOwnProperty(p) && !(p in base)){
				base[p] = ext[p];
			} else if(base[p] instanceof Object){
				merge(base[p], ext[p]);
			}
		}
	}
	return base
}